clc
clear

[s,Fs] = audioread('AD1866 + LM4562 (DAC + Reconstruction Filter)/REC_1kHz.wav');
startingTime = 1;
nHarmonics = 20;
sL = s(:,1);
sR = s(:,2);
s = sR;
s = s(startingTime*Fs:end);
s = s - mean(s);

t = 0:1/Fs:(size(s,1)- 1)/Fs;
figure(1)
plot(t,s)

% Create a Kaiser Window with beta = 38
w = kaiser(numel(s),38);
[Sxx, F] = periodogram(s,w,numel(s),Fs,'power');
rbw = enbw(w,Fs);

% SNR
% Measure snr on the power spectrum
SNR_SPECT = snr(Sxx,F,rbw,'power', nHarmonics)
figure(2);
% annotate the spectrum
snr(Sxx,F,rbw,'power', nHarmonics);

%THD
[THD_DB, hPower, hFreq] = thd(Sxx,F,rbw,'power', nHarmonics);
THD_DB
THD = 10^(2+(THD_DB/20))
% plot and annotate the spectrum
figure(3);
thd(Sxx,F,rbw,'power', nHarmonics);